Subject: Re: [RFC PATCH net-next] net: sched: flower: refactor reoffload for concurrent access

From: Vlad Buslov <[email-masked]>
Date: Thu, 18 Apr 2019 17:58:26 +0000

On Thu 18 Apr 2019 at 20:46, Jakub Kicinski <[email-masked]> wrote:
> On Thu, 18 Apr 2019 16:33:22 +0000, Vlad Buslov wrote:
>> Considering this, I tried to improve my solution to remove possibility
>> of multiple adds of same filter and it seems to me that it would be
>> enough to move hw_filters list management in flower offloads functions:
>> add filter to list while holding rtnl lock in fl_hw_replace_filter() and
>> remove it from list while holding rtnl lock in fl_hw_destroy_filter().
>> What do you think?
>
> Sounds good for now, but I presume the plan is to get rid of rtnl
> around the driver call.. at which point we would switch to a rwlock? :)

Yes, but I would like the lock to be in cls hw offloads API
(tc_setup_cb_replace(), etc) and not in flower itself. That would also
solve deadlock issue and make code reusable for any further unlocked
classifiers implementations.